"""A few methods for the Test Producers

This module provides the hostname and hostid of the machine.

Author: Thomas Low <thomas.low@cern.ch>
"""

import os, socket

def _getFingerprint():
	"""Returns an hopefully unique string for an arbitrary worker node."""
	linux = "echo -n "+_getMacAddress()+_getHostId()+" | md5sum | sed 's/ .*//'"
	return os.popen(linux).readline().split()[0]

def _getHostId():
	"""Returns the hostid of the machine."""
	return os.popen("hostid").readline().split()[0]

def _getHostName():
	"""Returns the host name of the machine."""
	return socket.gethostname()

def _getMacAddress():	
	"""Returns the first mac address found on the machine.""" 
	mac = "nomac"
	f = os.popen("/sbin/ifconfig")
	line = f.readline()
	while line: 
		if line.find('HWaddr') > -1: 
			mac = line.split()[4].replace(":","")
			break 
		line = f.readline()
	return mac
	
hostname 	= _getHostName()
hostid 		= _getFingerprint()
